var contextsearch = {

  load: function() {

    contextsearch.contextitem = document.getElementById("context-searchmenu");
    
    document.getElementById("contentAreaContextMenu").addEventListener("popupshowing",contextsearch.popuphandler,false);
    window.removeEventListener("load", contextsearch.load, false);
  },
  
  popuphandler : function() {
    document.getElementById("context-searchselect").hidden = "true";
          
    if (gContextMenu.isTextSelected) {
    
      var text = gContextMenu.searchSelected();
      if (text.length > 15) text = text.substr(0,15) + "...";
      
      var bundle = srGetStrBundle("chrome://communicator/locale/contentAreaCommands.properties");
      //text = gNavigatorBundle.getFormattedString("searchText", [text]);
      text = bundle.formatStringFromName("searchText", [text], 1);
      
      contextsearch.contextitem.setAttribute("label", text);
      contextsearch.contextitem.setAttribute("hidden","false");
          
    }

    else {
      contextsearch.contextitem.setAttribute("hidden","true");
    }
       
  },
  
  search : function(aEvent) {
  
    if (!aEvent.target.id)
      return;
  
    var searchUrl = contextsearch.geturl(aEvent.target.id, gContextMenu.searchSelected()); 
    
    var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                  .getService(Components.interfaces.nsIPrefService);
    
    var loadInBackgroundPref = prefs.getBoolPref("browser.tabs.loadInBackground");

    var loadInForeground = false;
    
    if (aEvent.button == undefined) {
      loadInForeground = loadInBackgroundPref ? aEvent.ctrlKey : !aEvent.ctrlKey;
    }
    
    else {
      loadInForeground = loadInBackgroundPref ? true : false;
    }

    if (aEvent.shiftKey) {
      openNewWindowWith(searchUrl);
    }    
      
    else {
      var newTab = getBrowser().addTab(searchUrl);
      if (loadInForeground) {
        window.getBrowser().selectedTab = newTab;
      }
    }
  },
  
  geturl: function(searchEngine,searchValue) {
  
  	var iSearchService = Components.classes['@mozilla.org/rdf/datasource;1?name=internetsearch']
  	                       .getService(Components.interfaces.nsIInternetSearchService);
  	                       
  	var searchUrl = iSearchService.GetInternetSearchURL(searchEngine, encodeURIComponent(searchValue), 0, 0, {value: 0});
  	var finalUrl = new String();
  	
  	if (!searchValue) {
  		var uri = Components.classes['@mozilla.org/network/standard-url;1']
  		            .createInstance(Components.interfaces.nsIURI);
  		uri.spec = searchUrl;
  		searchUrl = uri.host;
    }

    // recommendation by Mat on AMO
    for (var i = 0; i < searchUrl.length; i++) {
      finalUrl += (searchUrl[i] == "+") ? "%20" : searchUrl[i];
    }

  	return searchUrl;
	}
}

window.addEventListener("load",contextsearch.load,true);